Index: packages/linuxbios/serengeti_cheetah.mk
===================================================================
--- packages/linuxbios/serengeti_cheetah.mk	(revision 88)
+++ packages/linuxbios/serengeti_cheetah.mk	(working copy)
@@ -16,7 +16,16 @@
 endif
 
 
+ifeq ($(CONFIG_PLATFORM_CHEETAH_FAM10),y)
 ifeq ($(CONFIG_PAYLOAD_LAB),y)
+	LINUXBIOS_PATCHES += $(PACKAGE_DIR)/linuxbios/patches/serengeti_cheetah_fam10-lab.patch
+else
+	LINUXBIOS_PATCHES += $(PACKAGE_DIR)/linuxbios/patches/serengeti_cheetah_fam10-payload.patch
+endif
+endif
+
+ifeq ($(CONFIG_PLATFORM_SERENGETI_CHEETAH),y)
+ifeq ($(CONFIG_PAYLOAD_LAB),y)
 	LINUXBIOS_PATCHES += $(PACKAGE_DIR)/linuxbios/patches/serengeti_cheetah-lab.patch
 else
 	LINUXBIOS_PATCHES += $(PACKAGE_DIR)/linuxbios/patches/serengeti_cheetah-payload.patch
@@ -25,6 +34,7 @@
 ifeq ($(CONFIG_SIMNOW),y)
 LINUXBIOS_PATCHES += $(PACKAGE_DIR)/linuxbios/patches/simnow.patch
 endif
+endif
 
 LINUXBIOS_BASE_DIR=svn
 LINUXBIOS_URL=svn://linuxbios.org/repos/trunk/LinuxBIOSv2
Index: packages/linuxbios/patches/serengeti_cheetah_fam10-lab.patch
===================================================================
--- packages/linuxbios/patches/serengeti_cheetah_fam10-lab.patch	(revision 0)
+++ packages/linuxbios/patches/serengeti_cheetah_fam10-lab.patch	(revision 0)
@@ -0,0 +1,45 @@
+Index: svn/targets/amd/serengeti_cheetah_fam10/Config.lb
+===================================================================
+--- svn/targets/amd/serengeti_cheetah_fam10/Config.lb	(revision 3018)
++++ svn/targets/amd/serengeti_cheetah_fam10/Config.lb	(working copy)
+@@ -29,29 +29,14 @@
+ # At a maximum only compile in this level of debugging
+ 	option  MAXIMUM_CONSOLE_LOGLEVEL=11
+ 
+-# 512KB ROM
+-option ROM_SIZE=512*1024
++# 1024KB ROM
++option ROM_SIZE=1024*1024
++option FALLBACK_SIZE=ROM_SIZE-FAILOVER_SIZE
+ 
+-# Cheetah Family 10
+-#romimage "normal"
+-#	1MB ROM
+-#	option ROM_SIZE = 0x100000
+-#	option USE_FAILOVER_IMAGE=0
+-#	option USE_FALLBACK_IMAGE=0
+-#	option ROM_IMAGE_SIZE=0x20000
+-#	option ROM_IMAGE_SIZE=0x30000
+-#	option XIP_ROM_SIZE=0x40000
+-#	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
+-#	payload ../payload.elf
+-#end
+-
+ romimage "fallback"
+ 	option USE_FAILOVER_IMAGE=0
+ 	option USE_FALLBACK_IMAGE=1
+-#	option ROM_IMAGE_SIZE=0x13800
+-#	option ROM_IMAGE_SIZE=0x19800
+-	option ROM_IMAGE_SIZE=0x3f000
+-#	option ROM_IMAGE_SIZE=0x15800
++	option ROM_IMAGE_SIZE=0x30000
+ 	option XIP_ROM_SIZE=0x40000
+ 	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
+ 	payload ../payload.elf
+@@ -65,6 +50,5 @@
+ 	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Failover"
+ end
+ 
+-#buildrom ./amd-cheetah-fam10.rom ROM_SIZE "normal" "fallback" "failover"
+ buildrom ./amd-cheetah-fam10.rom ROM_SIZE "fallback" "failover"
+ 
Index: packages/linuxbios/patches/serengeti_cheetah_fam10-payload.patch
===================================================================
--- packages/linuxbios/patches/serengeti_cheetah_fam10-payload.patch	(revision 0)
+++ packages/linuxbios/patches/serengeti_cheetah_fam10-payload.patch	(revision 0)
@@ -0,0 +1,38 @@
+Index: svn/targets/amd/serengeti_cheetah_fam10/Config.lb
+===================================================================
+--- svn/targets/amd/serengeti_cheetah_fam10/Config.lb	(revision 3018)
++++ svn/targets/amd/serengeti_cheetah_fam10/Config.lb	(working copy)
+@@ -32,26 +32,10 @@
+ # 512KB ROM
+ option ROM_SIZE=512*1024
+ 
+-# Cheetah Family 10
+-#romimage "normal"
+-#	1MB ROM
+-#	option ROM_SIZE = 0x100000
+-#	option USE_FAILOVER_IMAGE=0
+-#	option USE_FALLBACK_IMAGE=0
+-#	option ROM_IMAGE_SIZE=0x20000
+-#	option ROM_IMAGE_SIZE=0x30000
+-#	option XIP_ROM_SIZE=0x40000
+-#	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
+-#	payload ../payload.elf
+-#end
+-
+ romimage "fallback"
+ 	option USE_FAILOVER_IMAGE=0
+ 	option USE_FALLBACK_IMAGE=1
+-#	option ROM_IMAGE_SIZE=0x13800
+-#	option ROM_IMAGE_SIZE=0x19800
+ 	option ROM_IMAGE_SIZE=0x3f000
+-#	option ROM_IMAGE_SIZE=0x15800
+ 	option XIP_ROM_SIZE=0x40000
+ 	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
+ 	payload ../payload.elf
+@@ -65,6 +49,5 @@
+ 	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Failover"
+ end
+ 
+-#buildrom ./amd-cheetah-fam10.rom ROM_SIZE "normal" "fallback" "failover"
+ buildrom ./amd-cheetah-fam10.rom ROM_SIZE "fallback" "failover"
+ 