Index: fintek.c
===================================================================
--- fintek.c	(revision 3049)
+++ fintek.c	(working copy)
@@ -3,6 +3,7 @@
  *
  * Copyright (C) 2006 coresystems GmbH <info@coresystems.de>
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -99,3 +100,7 @@
 
 	exit_conf_mode_winbond_fintek_ite_8787(port);
 }
+
+void print_fintek_chips(void) {
+	print_vendor_chips("Fintek", reg_table);
+}
Index: winbond.c
===================================================================
--- winbond.c	(revision 3049)
+++ winbond.c	(working copy)
@@ -2,6 +2,7 @@
  * This file is part of the superiotool project.
  *
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -445,3 +446,7 @@
 	probe_idregs_winbond_helper("(init=0x87,0x87) ", port);
 	exit_conf_mode_winbond_fintek_ite_8787(port);
 }
+
+void print_winbond_chips(void) {
+	print_vendor_chips("Winbond", reg_table);
+}
Index: ite.c
===================================================================
--- ite.c	(revision 3049)
+++ ite.c	(working copy)
@@ -3,6 +3,7 @@
  *
  * Copyright (C) 2007 Carl-Daniel Hailfinger
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -380,3 +381,7 @@
 	probe_idregs_ite_helper("(init=0x87,0x87) ", port);
 	exit_conf_mode_winbond_fintek_ite_8787(port);
 }
+
+void print_ite_chips(void) {
+	print_vendor_chips("ITE", reg_table);
+}
Index: nsc.c
===================================================================
--- nsc.c	(revision 3049)
+++ nsc.c	(working copy)
@@ -3,6 +3,7 @@
  *
  * Copyright (C) 2006 Ronald Minnich <rminnich@gmail.com>
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -449,3 +450,7 @@
 
 	dump_superio("NSC", reg_table, port, id);
 }
+
+void print_nsc_chips(void) {
+	print_vendor_chips("NSC", reg_table);
+}
Index: superiotool.c
===================================================================
--- superiotool.c	(revision 3049)
+++ superiotool.c	(working copy)
@@ -4,6 +4,7 @@
  * Copyright (C) 2006 Ronald Minnich <rminnich@gmail.com>
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
  * Copyright (C) 2007 Carl-Daniel Hailfinger
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -161,6 +162,47 @@
 	       vendor, info, port);
 }
 
+/* Print information about a specific chip. */
+void print_chip(const char *vendor, const struct superio_registers reg) {
+	printf("%s %s", vendor, reg.name);
+	/* Unless the ldn is empty, assume this chip has a dump. */
+	if(reg.ldn[0].ldn != EOT)
+		printf(" (dump available)");
+	printf("\n");
+}
+
+/* Print a list of all supported chips from the given vendor. */
+void print_vendor_chips(const char *vendor,
+			const struct superio_registers reg_table[]) {	
+	int i;
+	
+	for (i = 0; reg_table[i].superio_id != EOT; i++) {
+		print_chip(vendor, reg_table[i]);
+	}
+
+	/* If we printed any chips for this vendor, put in a blank line. */
+	if (i != 0)
+		printf("\n");
+}
+
+/* Print a list of all chips supported by superiotool. */
+void print_list_of_supported_chips(void)
+{
+	int i;
+	
+	printf("\n");
+	printf("Supported Super I/O Chips:\n");
+	printf("\n");
+	
+	for (i = 0; i < ARRAY_SIZE(vendor_print_functions); i++) {
+		vendor_print_functions[i].print_list();
+	}
+	
+	printf("See <http://coreboot.org/Superiotool#Supported_devices> for more information\n");
+	printf("\n");
+
+}
+
 static void print_version(void)
 {
 	printf("superiotool r%s\n", SUPERIOTOOL_VERSION);
@@ -172,18 +214,23 @@
 
 	static const struct option long_options[] = {
 		{"dump",		no_argument, NULL, 'd'},
+		{"list-supported",	no_argument, NULL, 'l'},
 		{"verbose",		no_argument, NULL, 'V'},
 		{"version",		no_argument, NULL, 'v'},
 		{"help",		no_argument, NULL, 'h'},
 		{0, 0, 0, 0}
 	};
 
-	while ((opt = getopt_long(argc, argv, "dVvh",
+	while ((opt = getopt_long(argc, argv, "dlVvh",
 				  long_options, &option_index)) != EOF) {
 		switch (opt) {
 		case 'd':
 			dump = 1;
 			break;
+		case 'l':
+			print_list_of_supported_chips();
+			exit(0);
+			break;
 		case 'V':
 			verbose = 1;
 			break;
Index: ali.c
===================================================================
--- ali.c	(revision 3049)
+++ ali.c	(working copy)
@@ -2,6 +2,7 @@
  * This file is part of the superiotool project.
  *
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -99,3 +100,7 @@
 
 	exit_conf_mode_ali(port);
 }
+
+void print_ali_chips(void) {
+	print_vendor_chips("ALi", reg_table);
+}
Index: smsc.c
===================================================================
--- smsc.c	(revision 3049)
+++ smsc.c	(working copy)
@@ -2,6 +2,7 @@
  * This file is part of the superiotool project.
  *
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -546,3 +547,7 @@
 	probe_idregs_smsc_helper(port, DEVICE_ID_REG, DEVICE_REV_REG);
 	probe_idregs_smsc_helper(port, DEVICE_ID_REG_OLD, DEVICE_REV_REG_OLD);
 }
+
+void print_smsc_chips(void) {
+	print_vendor_chips("SMSC", reg_table);
+}
Index: superiotool.8
===================================================================
--- superiotool.8	(revision 3049)
+++ superiotool.8	(working copy)
@@ -1,8 +1,8 @@
-.TH SUPERIOTOOL 8 "October 11, 2007"
+.TH SUPERIOTOOL 8 "January 13, 2008"
 .SH NAME
 superiotool \- Super I/O detection tool
 .SH SYNOPSIS
-.B superiotool \fR[\fB\-dVvh\fR] 
+.B superiotool \fR[\fB\-dlVvh\fR] 
 .SH DESCRIPTION
 .B superiotool
 is a GPL'd user-space utility which can
@@ -72,6 +72,37 @@
 detailed information about the
 .BR MM " fields."
 .TP
+.B "\-l, \-\-list-supported"
+List all Super I/O chips recognized by
+.B superiotool\c
+\&. The output will look like this:
+.sp
+.B $ ./superiotool -l
+.br
+Supported Super I/O Chips:
+.br
+
+.br
+ALi M1535/M1535D/M1535+/M1535D+ (dump available)
+.br
+ALi M512x
+.br
+
+.br
+Fintek F71862FG
+.br
+Fintek F71872F/FG / F71806F/FG
+.br
+\&...
+.sp
+The phrase
+.B (dump available)
+following a chip name indicates that
+.B superiotool
+supports the
+.B --dump
+option for this chip.
+.TP
 .B "\-V, \-\-verbose"
 Enable verbose mode. This option can be used together with the
 .BR "\-d" " option."
Index: superiotool.h
===================================================================
--- superiotool.h	(revision 3049)
+++ superiotool.h	(working copy)
@@ -3,6 +3,7 @@
  *
  * Copyright (C) 2007 Carl-Daniel Hailfinger
  * Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+ * Copyright (C) 2008 Robinson P. Tryon <bishop.robinson@gmail.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -81,23 +82,34 @@
 		  uint16_t port, uint16_t id);
 void probing_for(const char *vendor, const char *info, uint16_t port);
 
+void print_chip(const char *vendor, const struct superio_registers reg);
+void print_vendor_chips(const char *vendor,
+			const struct superio_registers reg_table[]);
+void print_list_of_supported_chips(void);
+
 /* ali.c */
 void probe_idregs_ali(uint16_t port);
+void print_ali_chips(void);
 
 /* fintek.c */
 void probe_idregs_fintek(uint16_t port);
+void print_fintek_chips(void);
 
 /* ite.c */
 void probe_idregs_ite(uint16_t port);
+void print_ite_chips(void);
 
 /* nsc.c */
 void probe_idregs_nsc(uint16_t port);
+void print_nsc_chips(void);
 
 /* smsc.c */
 void probe_idregs_smsc(uint16_t port);
+void print_smsc_chips(void);
 
 /* winbond.c */
 void probe_idregs_winbond(uint16_t port);
+void print_winbond_chips(void);
 
 /** Table of which config ports to probe for each Super I/O family. */
 static const struct {
@@ -112,4 +124,16 @@
 	{probe_idregs_winbond,	{0x2e, 0x4e, 0x3f0, 0x370, 0x250, EOT}},
 };
 
+
+/** Table of functions to print out supported Super I/O chips for each vendor */
+static const struct {
+	void (*print_list) (void);
+} vendor_print_functions [] = {
+	{print_ali_chips},
+	{print_fintek_chips},
+	{print_ite_chips},
+	{print_nsc_chips},
+	{print_smsc_chips},
+	{print_winbond_chips}};
+
 #endif