Index: buildrom-devel/config/platforms/db800.conf
===================================================================
--- buildrom-devel/config/platforms/db800.conf	(revision 98)
+++ buildrom-devel/config/platforms/db800.conf	(working copy)
@@ -13,7 +13,7 @@
 # Targets
 # Use the same settings as the Norwich platform
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/norwich-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/norwich.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/norwich.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/tyan-s2882.conf
===================================================================
--- buildrom-devel/config/platforms/tyan-s2882.conf	(revision 98)
+++ buildrom-devel/config/platforms/tyan-s2882.conf	(working copy)
@@ -16,7 +16,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/tyan-s2882-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/tyan-s2882.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/tyan-s2882.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/tyan-s2891.conf
===================================================================
--- buildrom-devel/config/platforms/tyan-s2891.conf	(revision 98)
+++ buildrom-devel/config/platforms/tyan-s2891.conf	(working copy)
@@ -16,7 +16,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/tyan-s2891-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/tyan-s2891.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/tyan-s2891.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/m57sli.conf
===================================================================
--- buildrom-devel/config/platforms/m57sli.conf	(revision 98)
+++ buildrom-devel/config/platforms/m57sli.conf	(working copy)
@@ -16,7 +16,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/m57sli-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/m57sli.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/m57sli.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/dbe61.conf
===================================================================
--- buildrom-devel/config/platforms/dbe61.conf	(revision 98)
+++ buildrom-devel/config/platforms/dbe61.conf	(working copy)
@@ -13,7 +13,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/norwich-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/norwich.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/norwich.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/alix1c.conf
===================================================================
--- buildrom-devel/config/platforms/alix1c.conf	(revision 98)
+++ buildrom-devel/config/platforms/alix1c.conf	(working copy)
@@ -11,7 +11,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/alix1c-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/alix1c.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/alix1c.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/msm800sev.conf
===================================================================
--- buildrom-devel/config/platforms/msm800sev.conf	(revision 98)
+++ buildrom-devel/config/platforms/msm800sev.conf	(working copy)
@@ -12,7 +12,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/msm800sev-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/msm800sev.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/msm800sev.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/serengeti_cheetah.conf
===================================================================
--- buildrom-devel/config/platforms/serengeti_cheetah.conf	(revision 98)
+++ buildrom-devel/config/platforms/serengeti_cheetah.conf	(working copy)
@@ -17,14 +17,14 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/serengeti_cheetah-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/serengeti_cheetah.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/serengeti_cheetah.mk
 
 # kernel configuration (for LAB)
 
 ifeq ($(CONFIG_TARGET_64BIT),y)
 KERNEL_VERSION=2.6.22.2
-KERNEL_MK=$(PACKAGE_DIR)/kernel/serengeti_cheetah-kernel-x86_64.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/serengeti_cheetah-x86_64.mk
 KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-serengeti_cheetah-x86_64
 BUSYBOX_CONFIG=defconfig-serengeti_cheetah-x86_64
 UCLIBC_VER=0.9.29
Index: buildrom-devel/config/platforms/qemu.conf
===================================================================
--- buildrom-devel/config/platforms/qemu.conf	(revision 98)
+++ buildrom-devel/config/platforms/qemu.conf	(working copy)
@@ -11,7 +11,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/qemu-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/qemu.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/qemu.mk
 
 # kernel configuration (for LAB)
@@ -26,14 +26,13 @@
 # coreboot-v2 configuration
 CBV2_TAG=2950
 CBV2_CONFIG=Config.lb
-COREBOOT_ROM_NAME=qemu.rom
 CBV2_TDIR=qemu-i386
 
 # coreboot v3 configuration
 CBV3_CONFIG=qemu-i386-defconfig
 CBV3_TAG=HEAD
-CBV3_ROM_NAME=linuxbios.rom
 
+COREBOOT_ROM_NAME=qemu.rom
 COREBOOT_VENDOR=emulation
 COREBOOT_BOARD=qemu-i386
 
Index: buildrom-devel/config/platforms/supermicro-h8dmr.conf
===================================================================
--- buildrom-devel/config/platforms/supermicro-h8dmr.conf	(revision 98)
+++ buildrom-devel/config/platforms/supermicro-h8dmr.conf	(working copy)
@@ -16,7 +16,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/supermicro-h8dmr-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/supermicro-h8dmr.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/supermicro-h8dmr.mk
 
 # kernel configuration (for LAB)
Index: buildrom-devel/config/platforms/norwich.conf
===================================================================
--- buildrom-devel/config/platforms/norwich.conf	(revision 98)
+++ buildrom-devel/config/platforms/norwich.conf	(working copy)
@@ -12,7 +12,7 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/norwich-kernel.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/norwich.mk
 CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/norwich.mk
 
 # kernel configuration (for LAB)