include/device/device.h:
Change the ID constants so they are more useful for debugging. 
Instead of simple 1,2,3 they now are a 4-byte value which can be more
useful when looking at memory with a debugger. Lots of variables can be 
'1', but fewer variables will match to 'PCID'. 

include/device/pci.h: 
Include pci_ids.h in pci.h

device/device.c: remove silly comment. Change memcpy to struct assign, this makes it possible 
for the C compiler to do type checking. Add assign for the dev->id. 

flattree.c: Support the use of 'domainid' and 'pciid' in the per-chip dts. These IDs will be assigned
to the static tree device struct. In conjunction with the earlier patch, this change removes the need
for users to assign the ops struct member in the dts by hand, as it is done in the qemu port today. 
The ops struct member will automatically be assigned by the dev_init function, which is run 
in stage2 before any actual device code is run. (This change to dev_init was in the previous patch). 
Added two comments that document what is going on. 

Signed-off-by: Ronald G. Minnich <rminnich@gmail.com>


Index: include/device/device.h
===================================================================
--- include/device/device.h	(revision 556)
+++ include/device/device.h	(working copy)
@@ -25,18 +25,28 @@
 #include <device/resource.h>
 #include <device/path.h>
 
+/**
+ * Create a 32-bit value from four characters. This is better
+ * than the usual enum values when using (JTAG) debuggers.
+ * It also makes it harder for accidentally assigned type values
+ * to be mistaken for a real value -- e.g. it is more likely in the event
+ * of a programming error that a '1' is somehow assigned
+ * to the type field, whereas these values are more complex. 
+ * Thus errors may be easier to find. 
+ */
+#define TYPENAME(a,b,c,d) ((a<<24)|(b<<16)|(c<<8)|(d))
 #define DEVICE_ID_MAX 64
 enum device_id_type {
-	DEVICE_ID_NONE = 0,
-	DEVICE_ID_ROOT,
-	DEVICE_ID_PCI,
-	DEVICE_ID_PNP,
-	DEVICE_ID_I2C,
-	DEVICE_ID_APIC,
-	DEVICE_ID_PCI_DOMAIN,
-	DEVICE_ID_APIC_CLUSTER,
-	DEVICE_ID_CPU,
-	DEVICE_ID_CPU_BUS,
+	DEVICE_ID_NONE	= 0,
+	DEVICE_ID_ROOT	= TYPENAME('R','O','O','T'),
+	DEVICE_ID_PCI	= TYPENAME(' ','P','C','I'),
+	DEVICE_ID_PNP	= TYPENAME(' ','P','N','P'),
+	DEVICE_ID_I2C	= TYPENAME(' ','I','2','C'),
+	DEVICE_ID_APIC	= TYPENAME('A','P','I','C'),
+	DEVICE_ID_PCI_DOMAIN = TYPENAME('P','C','I','D'),
+	DEVICE_ID_APIC_CLUSTER = TYPENAME('A','P','C','C'),
+	DEVICE_ID_CPU = TYPENAME(' ','C','P','U'),
+	DEVICE_ID_CPU_BUS =  TYPENAME(' ','B','U','S'),
 };
 
 struct device;
Index: include/device/pci.h
===================================================================
--- include/device/pci.h	(revision 554)
+++ include/device/pci.h	(working copy)
@@ -29,6 +29,7 @@
 #include <device/device.h>
 #include <device/pci_ops.h>
 #include <device/pci_rom.h>
+#include <device/pci_ids.h>
 
 /*
  *	For more information, please consult the following manuals (look at
Index: device/device.c
===================================================================
--- device/device.c	(revision 556)
+++ device/device.c	(working copy)
@@ -209,11 +209,12 @@
 	}
 
 	dev = new_device();
-	if (!dev) /* Please don't do this at home */
+	if (!dev)
 		goto out;
 
 	memset(dev, 0, sizeof(*dev));
-	memcpy(&dev->path, path, sizeof(*path));
+	dev->path = *path;
+	dev->id = *devid;
 
 	/* Initialize the back pointers in the link fields. */
 	for (link = 0; link < MAX_LINKS; link++) {
Index: util/dtc/flattree.c
===================================================================
--- util/dtc/flattree.c	(revision 554)
+++ util/dtc/flattree.c	(working copy)
@@ -532,7 +532,33 @@
 	if (tree->config){
 		configname = clean(tree->label, 0);
 		printf("\t.device_configuration = &%s,\n", configname);
+		/* The config property list for a device is derived from the
+		 * device dts, e.g. northbridge/intel/i440bx/dts, not the
+		 * mainboard dts. 
+		 * Almost all of these properties are specific to the device. 
+		 * Some, such as the device id, are part of the common
+		 * device struct. Check the config properties and 
+		 * pull out those properties that are for the common 
+		 * (a.k.a. generic) device struct. 
+		 */
+		/* get the properties out that are generic device props */
+		for_each_config(tree, prop) {
+			if (streq(prop->name, "domainid")){
+				fprintf(f, "\t.id = {.type=DEVICE_ID_PCI_DOMAIN,.u={.pci_domain={ %s }}},\n", 
+					prop->val.val);
+			}
+			if (streq(prop->name, "pciid")){
+				fprintf(f, "\t.id = {.type=DEVICE_ID_PCI,.u={.pci={ %s }}},\n", 
+					prop->val.val);
+			}
+		}
 	}
+	/* Process the properties specified in the mainboard dts. 
+	 * Some of these properties require special initialization 
+	 * (e.g. the path); some are flags, i.e. if the property exists
+	 * then a variable is set to 1 (e.g. on_mainboard); 
+	 * and some are just set directly into the code (e.g. ops_pci).
+	 */
 	for_each_property(tree, prop) {
 		if (streq(prop->name, "pcidomain")){
 			fprintf(f, "\t.path = {.type=DEVICE_PATH_PCI_DOMAIN,.u={.pci_domain={ .domain = %s }}},\n", 