Index: svn/targets/emulation/qemu-i386/Config-abuild.lb
===================================================================
--- svn/targets/emulation/qemu-i386/Config-abuild.lb	(revision 3079)
+++ svn/targets/emulation/qemu-i386/Config-abuild.lb	(working copy)
@@ -18,5 +18,5 @@
 	payload __PAYLOAD__
 end
 
-buildrom ./qemu-bios.rom ROM_SIZE "image"
+buildrom ./coreboot.rom ROM_SIZE "image"
 
Index: svn/targets/emulation/qemu-i386/Config.lb
===================================================================
--- svn/targets/emulation/qemu-i386/Config.lb	(revision 3079)
+++ svn/targets/emulation/qemu-i386/Config.lb	(working copy)
@@ -16,5 +16,5 @@
 	payload /home/stepan/core.img
 end
 
-buildrom ./qemu-bios.rom ROM_SIZE "image"
+buildrom ./coreboot.rom ROM_SIZE "image"
 
Index: svn/targets/technologic/ts5300/Config.lb
===================================================================
--- svn/targets/technologic/ts5300/Config.lb	(revision 3079)
+++ svn/targets/technologic/ts5300/Config.lb	(working copy)
@@ -29,4 +29,4 @@
 	payload /home/stepan/filo-ts5300.elf
 end
 
-buildrom ./technologic_ts5300.rom ROM_SIZE  "fallback"
+buildrom ./coreboot.rom ROM_SIZE  "fallback"
Index: svn/targets/amd/norwich/Config.lb
===================================================================
--- svn/targets/amd/norwich/Config.lb	(revision 3079)
+++ svn/targets/amd/norwich/Config.lb	(working copy)
@@ -46,4 +46,4 @@
 	payload ../payload.elf
 end
 
-buildrom ./norwich.rom ROM_SIZE "fallback"
+buildrom ./coreboot.rom ROM_SIZE "fallback"
Index: svn/targets/amd/serengeti_cheetah_fam10/Config.lb
===================================================================
--- svn/targets/amd/serengeti_cheetah_fam10/Config.lb	(revision 3079)
+++ svn/targets/amd/serengeti_cheetah_fam10/Config.lb	(working copy)
@@ -65,6 +65,6 @@
 	option COREBOOT_EXTRA_VERSION="$(shell cat ../../VERSION)_Failover"
 end
 
-#buildrom ./amd-cheetah-fam10.rom ROM_SIZE "normal" "fallback" "failover"
-buildrom ./amd-cheetah-fam10.rom ROM_SIZE "fallback" "failover"
+#buildrom ./coreboot.rom ROM_SIZE "normal" "fallback" "failover"
+buildrom ./coreboot.rom ROM_SIZE "fallback" "failover"
 
Index: svn/targets/amd/db800/Config.lb
===================================================================
--- svn/targets/amd/db800/Config.lb	(revision 3079)
+++ svn/targets/amd/db800/Config.lb	(working copy)
@@ -46,4 +46,4 @@
 	payload ../payload.elf
 end
 
-buildrom ./db800.rom ROM_SIZE "fallback"
+buildrom ./coreboot.rom ROM_SIZE "fallback"
Index: svn/targets/artecgroup/dbe61/Config.lb
===================================================================
--- svn/targets/artecgroup/dbe61/Config.lb	(revision 3079)
+++ svn/targets/artecgroup/dbe61/Config.lb	(working copy)
@@ -31,4 +31,4 @@
 	payload ../payload.elf
 end
 
-buildrom ./dbe61.rom ROM_SIZE  "fallback"
+buildrom ./coreboot.rom ROM_SIZE  "fallback"
Index: svn/targets/msi/ms9282/Config.lb
===================================================================
--- svn/targets/msi/ms9282/Config.lb	(revision 3079)
+++ svn/targets/msi/ms9282/Config.lb	(working copy)
@@ -88,4 +88,4 @@
 #      payload ../../../payloads/tg3--eepro100--e1000--filo_hda2_com2.zelf
 end
 
-buildrom ./ms9282.lxb ROM_SIZE "normal" "fallback"
+buildrom ./coreboot.rom ROM_SIZE "normal" "fallback"
Index: svn/targets/msi/ms9185/Config.lb
===================================================================
--- svn/targets/msi/ms9185/Config.lb	(revision 3079)
+++ svn/targets/msi/ms9185/Config.lb	(working copy)
@@ -91,4 +91,4 @@
 #      payload ../../../payloads/tg3--eepro100--e1000--filo_hda2_com2.zelf
 end
 
-buildrom ./ms9185.lxb ROM_SIZE "normal" "fallback"
+buildrom ./coreboot.rom ROM_SIZE "normal" "fallback"
Index: svn/targets/arima/hdama/Config.kernelimage.lb
===================================================================
--- svn/targets/arima/hdama/Config.kernelimage.lb	(revision 3079)
+++ svn/targets/arima/hdama/Config.kernelimage.lb	(working copy)
@@ -100,4 +100,4 @@
 #	payload /usr/share/etherboot/5.1.9pre2-lnxi-lb/tg3--ide_disk.zelf
 end
 
-buildrom ./luxbios.rom ROM_SIZE "fallback"
+buildrom ./coreboot.rom ROM_SIZE "fallback"
Index: svn/targets/newisys/khepri/Config.lb
===================================================================
--- svn/targets/newisys/khepri/Config.lb	(revision 3079)
+++ svn/targets/newisys/khepri/Config.lb	(working copy)
@@ -42,4 +42,4 @@
 	payload ../../../payloads/tg3--ide_disk.zelf
 end
 
-buildrom ./khepri.rom ROM_SIZE "normal" "fallback"
+buildrom ./coreboot.rom ROM_SIZE "normal" "fallback"
Index: svn/targets/agami/aruma/Config1M.lb
===================================================================
--- svn/targets/agami/aruma/Config1M.lb	(revision 3079)
+++ svn/targets/agami/aruma/Config1M.lb	(working copy)
@@ -21,4 +21,4 @@
 	payload ../../../../../../linux.elf
 end
 
-buildrom ./agami_aruma.rom ROM_SIZE "fallback"
+buildrom ./coreboot.rom ROM_SIZE "fallback"
Index: svn/targets/agami/aruma/Config.lb
===================================================================
--- svn/targets/agami/aruma/Config.lb	(revision 3079)
+++ svn/targets/agami/aruma/Config.lb	(working copy)
@@ -26,4 +26,4 @@
 	payload ../../../../../../filo.elf
 end
 
-buildrom ./agami_aruma.rom ROM_SIZE "normal" "fallback"
+buildrom ./coreboot.rom ROM_SIZE "normal" "fallback"